#include <stdio.h>
#ifdef MEMCHK
#include "trax.h"
#else
char *calloc(), *malloc();
#endif
#include "sym.h"
typedef Sym *Attrib;
#include "attrib.h"
#include "tokens.h"

#define SymStrTable		1000
#define HashSize		1001

struct _pre {
	char *symbol;
	int token;
};

struct _pre predef[] = {
	 /* Predefined Constants */
	 { "maxint", ConstID },

	 /* Predefined Types */
	 {"real", TypeID},
	 {"boolean", TypeID},
	 {"char", TypeID},
	 {"integer", TypeID},
	 {"text", TypeID},

	 /* Predefined Functions */
	 { "odd", FuncID },
	 { "eoln", FuncID },
	 { "eof", FuncID },
	 { "abs", FuncID },
	 { "sqr", FuncID },
	 { "sin", FuncID },
	 { "cos", FuncID },
	 { "arctan", FuncID },
	 { "ln", FuncID },
	 { "exp", FuncID },
	 { "sqrt", FuncID },
	 { "ord", FuncID },
	 { "chr", FuncID },
	 { "pred", FuncID },
	 { "succ", FuncID },
	 { "round", FuncID },
	 { "trunc", FuncID },

	 /* Predefined Procedures */
	 { "put", ProcID },
	 { "get", ProcID },
	 { "reset", ProcID },
	 { "rewrite", ProcID },
	 { "new", ProcID },
	 { "dispose", ProcID },
	 { "read", ProcID },
	 { "readln", ProcID },
	 { "write", ProcID },
	 { "writeln", ProcID },
	 { "page", ProcID },

	 {NULL, 0}
};

main(argc, argv)
int argc;
char *argv[];
{
	BLKvars;
	Sym *p;
	FILE *f;
	
	if ( argc==1 ) return;
	f = fopen(argv[1], "r");
	if ( f==NULL ) {fprintf(stderr, "Can't Open '%s'\n", argv[1]); return;}
	aSourceFile = argv[1];

	aSymInit(HashSize, SymStrTable);
	LoadSymTable();

	ANTLR(program, f);		/* Parse program from stdin */
	/*statsym();*/
	exit(0);
}

LoadSymTable()
{
	struct _pre *p = &(predef[0]);
	Sym *sym;

	while ( p->symbol != NULL )
	{
		sym = aSymNew(p->symbol);
		sym->token = p->token;
		aSymAdd(sym->symbol, sym);
		p++;
	}
}

addlist(list, token, level)
Sym *list;
int token, level;
{
	register Sym *p, *q;

	for (p=list; p!=NULL; p=q)
	{
		p->token = token;	/* Set token to that passed in */
		p->level = level;
		q = p->next;
		aSymAdd(p->symbol, p);
	}
}
